; File:     Printer10.asm
;------------------------------------------------------------------------------------------------------------------*****
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\comdlg32.inc            ; printer
    
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\comdlg32.lib             ; printer
    
; 
WinMain         proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc         proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA        proto   :DWORD,:DWORD,:DWORD,:DWORD

GetPrinterDC    proto   :DWORD,:DWORD
TextPrint       proto   :DWORD,:DWORD,:DWORD
CreateFontX     proto   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

RclRclCpy       proto   :DWORD,:DWORD
RclRclAdd       proto   :DWORD,:DWORD
CnvToRcl        proto   :DWORD,:DWORD
AllocMemo       proto   :DWORD
; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h

;----------- Menus ---------------------
IDM_Menu1        equ 1001
IDM_Menu2        equ 1002
IDM_Menu3        equ 1003
IDM_Menu4        equ 1004
;---------------------------------------

$ECRAWIDTH$         equ 1268              ; largura do exr
$ECRAHEIGHT$        equ 966               ; altura do ecr

MAXSIZE             equ 260
MAXBUFSIZE          equ 50000
;--------------------------------------
MAXCOLSIZE          equ 117 ;120             ; columns per line
MAXCOLSIZE4         equ 117+4       ;120 + 4
;MAXLINSIZE          equ 5000

MaxRegLst           equ 8
LenRegLst           equ 12
EndRegLst           equ 16
CorRegLst           equ 20

FRMPAGES            equ 100                     ; number of pages
FRMLINPAGES         equ 50                      ; lines per page
MAXLINSIZE          equ FRMPAGES * FRMLINPAGES  ; number of lines
;---------------------------------------
INVALID_SET_FILE_POINTER    equ 0FFFFFFFFh

;.......... To Open File ................
$ArquivoAll     equ FILE_ATTRIBUTE_ARCHIVE or FILE_ATTRIBUTE_READONLY or FILE_ATTRIBUTE_HIDDEN

$ShareFic       equ FILE_SHARE_READ or FILE_SHARE_WRITE 

$AbreOuErro     equ OPEN_EXISTING       ; Se Existe Abre

$ModoAberRd     equ GENERIC_READ 		            ; Modo de abertura para Leitura
;  Data Section 
.data
_MsgTit1    db 'Erro', 0
_MsgErro    db 'Erro', 0
_MsgErro1   db 'It isnt a text file', 0
_MsgErro2   db 'Choose a file to be printed', 0

_MsgTit2    db 'Teste', 0
_MsgTest    db 'Fonte Seleccionada', 0

_MsgTit3    db 'File Error', 0
_MsgTest3   db 'Erro ao Abrir ou Ler o ficheiro', 0

_MsgTit4    db 'File Error', 0
_MsgErro4   db 'The File is too long', 0

_MsgTit5    db 'Test 5', 0
_MsgTest5   db 'Estou aqui', 0

_MsgTit6    db 'Test 6', 0
_MsgTest6   db 'Estou aqui agora', 0
;----------------------------------------------------
_hpdc        dd 0
_hpFont      dd 0

;---------------------------------------
_FontMSSSerif   db 'MS Sans Serif',0

_DocTitle    db 'Documento',0

_mColumns    dd 120             ;Number of columns  160
_mLines      dd 50              ;Number of lines    84
_WidthCharX  dd ?
_HeightCharY dd ?
;....................................................................................

_MenuName    db 'Menu',0        ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Print Text Files',0
;+++++++++++++++++++++++++++++++++++++++++++++++++++
; see tute_11_3
_OurTitle       db 'Choose the file to open',0

_hFile          dd 0    ; handle
_lFile          dd 0    ; length
_BytesRead      dd 0

_FilterString   db "text Files", 0, "*.txt",0
                db "asm Files", 0, "*.asm",0
                db "bat Files", 0, "*.bat",0                
                db "rc Files", 0, "*.rc",0
                db "all Files", 0, "*.*", 0, 0
                ;
                dd MAXSIZE
                dd 0
_FileName       db MAXSIZE dup(0)
                db 0
                
                ; 
                ; File Buffer 
                ;   
;                dd MAXBUFSIZE
;                dd 0
;_bufferTxt      db MAXBUFSIZE dup(0)
;                db 0
                
                ; 
                ; File Buffer Formatted
                ; 
;                dd 0                            ; -20 CorRegLst
;                dd 0                            ; -16 EndRegLst
;                dd MAXCOLSIZE4                  ; -12 LenRegLst
;                dd MAXLINSIZE                   ;  -8 MaxRegLst
;                dd 0                            ;  -4 First String length
;_bufferFrm      db MAXLINSIZE dup ( MAXCOLSIZE4 dup (0) )
;                db 0
                ;
                dd 5
                dd 0
_PageNum        db 5 dup (0)
                db 0

                dd 5
_MsgPage        db 'Page '

                ; 
                ; Page X string 
                ; 
                dd 10
                dd 0
_PageBuf        db 10 dup (0)
                db 0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
;_hdc         dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>

_ofn         OPENFILENAME <?>

_lf          LOGFONT <?>
_di          DOCINFO <?>
_pd          PRINTDLG <?>
_tm          TEXTMETRIC  <?>
_rc          RECT <?>

_PosPrnX     dd ?            ; posio horizontal
_PosPrnY     dd ?            ; posio vertical

_NumPixelX   dd ?
_NumPixelY   dd ?

_LastTxtBuf  dd ?
_PageNumber  dd ?
;-------- Text buffer -------------
_pTxtMem     dd ?
_pTxtBuf     dd ?
;
_pFrmMem     dd ?
_pFrmBuf     dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax
    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            ;invoke    GetPrinterDC, 50, 120

            ; 
            ; Alloc mem for frm buffer
            ; 
            mov     _pFrmMem, 0
            mov     _pFrmBuf, 0
            ;
            mov     eax, MAXCOLSIZE4        ; 120 columns + 1 dword
            mov     ecx, MAXLINSIZE         ; number of lines
            mul     ecx                     ; eax = bytes needed
            add     eax, 24                 ; plus 24 bytes
            invoke  AllocMemo, eax
            jc      short @F
            ;
            mov     _pFrmMem, eax            
            add     eax, 20
            mov     _pFrmBuf, eax
            ;
            mov     dword ptr [eax - MaxRegLst], MAXLINSIZE
            mov     dword ptr [eax - LenRegLst], MAXCOLSIZE4             
            call    IniBufFrm

@@:         invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd
            
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
GetPrinterDC        proc    Lin:DWORD, Col:DWORD
                    ;
                    mov     eax, Lin
                    add     eax, 4
                    mov     _mLines, eax
                    ;
                    mov     eax, Col
                    mov     _mColumns, eax
                    
                    cmp     _hpdc, 0
                    je      short @F
                    ret
                    ;
@@:                 mov     _pd.lStructSize, sizeof PRINTDLG
                    mov     _pd.Flags, PD_RETURNDC or PD_USEDEVMODECOPIES
                    mov     _pd.nCopies, 1

                    invoke  PrintDlg, addr _pd
                    cmp     eax, TRUE
                    je      short @F

                    mov     _hpdc, 0
                    ret

@@:                 mov     eax, _pd.hDC
                    mov     _hpdc, eax
                    ;
                    ; Pixeis na HORIZONTAL
                    ; --------------------
                    invoke  GetDeviceCaps, _hpdc, HORZRES
                    mov     _NumPixelX, eax
                    ;
                    ; Pixeis na VERICAL
                    ; -----------------
	              invoke  GetDeviceCaps, _hpdc, VERTRES
                    mov     _NumPixelY, eax
                    ;
                    ; para termos _mColunas ...
                    ; -------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelX                    
                    div     _mColumns
                    mov     _WidthCharX, eax
                    ;
                    ; para termos _mLinhas ...
                    ; ------------------------
                    xor     edx, edx
                    mov     eax, _NumPixelY                                    
                    div     _mLines
        	        mov    _HeightCharY, eax

                    ; 
                    ; Font
                    ; 
                    mov       eax, _WidthCharX
        	        mov       edx, _HeightCharY
                    neg       edx
                    neg       eax
                    invoke    CreateFontX, addr _FontMSSSerif, edx, eax, FW_NORMAL, 0
                    jnc       short @F
                    ret
                    ;
@@:                 invoke    SelectObject, _hpdc, _hpFont

                    ;call      SendTeste
                    ret
GetPrinterDC        endp
; 
CreateFontX     proc    pName:DWORD, Alt:DWORD, Lgr:DWORD, Typ:DWORD, ID:DWORD

                mov     eax, Typ
                mov     _lf.lfWeight, eax
                
                mov     eax, Alt
                mov     _lf.lfHeight, eax
                mov     eax, Lgr       
                mov     _lf.lfWidth, eax
                ;
                mov     _lf.lfEscapement, 0
                mov     _lf.lfOrientation, 0
                mov     _lf.lfItalic, FALSE
                mov     _lf.lfUnderline, FALSE
                mov     _lf.lfStrikeOut, FALSE
                mov     _lf.lfCharSet, ANSI_CHARSET 
                mov     _lf.lfOutPrecision, OUT_DEFAULT_PRECIS or OUT_DEVICE_PRECIS
                mov     _lf.lfClipPrecision, CLIP_DEFAULT_PRECIS
                mov     _lf.lfQuality, PROOF_QUALITY        

                mov     al, DEFAULT_PITCH or FF_MODERN
                mov     edx, ID
                cmp     edx, 0
                je      @F
                             
                mov     al, DEFAULT_PITCH or FF_ROMAN
                cmp     edx, 1
                je      @F

                mov     al, DEFAULT_PITCH or FF_SWISS
                cmp     edx, 2
                je      @F

                mov     al, DEFAULT_PITCH or FF_SCRIPT
                cmp     edx, 3
                je      @F

                mov     al, DEFAULT_PITCH or FF_DECORATIVE
                cmp     edx, 4
                je      @F
                
                mov     al, DEFAULT_PITCH or FF_DONTCARE

@@:             mov     _lf.lfPitchAndFamily, al
                ;
                mov     edx, pName
                mov     ebx, offset _lf
                ;
@@:             movzx   eax, byte ptr [edx]                
                mov     byte ptr [ebx].LOGFONT.lfFaceName, al
                ;
                inc     edx
                inc     ebx
                ;
                or      eax, eax
                jnz     short @B

                invoke  CreateFontIndirect, addr _lf
                mov     _hpFont, eax
                ;
                cmp     eax, 0
                jne     short @F

                call    SendErro
                
                stc
                ret
                
@@:             clc
                ret
CreateFontX     endp
; 
PrintText           proc     

                    mov     ebx, _pFrmBuf                   ;offset _bufferFrm
                    cmp     dword ptr [ebx - EndRegLst], 0
                    jne     short @F

                    invoke  MessageBox, _hWnd, addr _MsgErro2, addr _MsgTit1, MB_OK 
                    ret

@@:                 cmp     _hpdc, 0
                    jne     short @F                    ; has DC ?

                    ; 
                    ; Get Printer DC 50 lines, 120 columns
                    ; 
                    invoke  GetPrinterDC, 50, 120
                    cmp     _hpdc, 0
                    jne     short @F
                    ret
                    
@@:                 mov     _PageNumber, 0

                    mov    _di.cbSize, SIZEOF _di
                    mov    _di.lpszDocName, offset _DocTitle
                    mov    _di.lpszOutput, NULL
                    mov    _di.fwType, NULL
                    ;
                    invoke  StartDoc, _hpdc, addr _di
                    cmp     eax, 0
                    jg      short @F
                    ret
                    
@@:                 call    PrintPage
                    jnc     short @B
                                     
                    invoke   DeleteObject, _hpFont
                    invoke   DeleteDC, _hpdc   
                    mov      _hpdc, 0

                    ; 
                    ; Destroy text buffer
                    ; 
                    call    IniBufFrm
                    ret
PrintText           endp
; 
PrintPage           proc
                    LOCAL   LinCor:DWORD, MaxLin:DWORD
                    ;
                    invoke  StartPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret

@@:                 mov     MaxLin, 49             ;_mLines
                    mov     LinCor, 2
                    
                    ; 
                    ; Number of the Page
                    ; 
                    inc     _PageNumber
                    invoke  CnvToRcl, _PageNumber, addr _PageNum

                    invoke  RclRclCpy, addr _MsgPage, addr _PageBuf  
                    invoke  RclRclAdd, addr _PageNum, addr _PageBuf  

                    invoke  TextPrint, addr _PageBuf, 1, 95
                    ;...............................................
                    
_start:             call    GetNxtLin
                    jnc     short @F
                    ;
                    ; Fim
                    ;
                    invoke  EndPage, _hpdc
                    invoke  EndDoc, _hpdc                    
                    stc
                    ret
                    ;                     
@@:                 invoke  TextPrint, edi, LinCor, 4
                    ;
                    inc     LinCor
                    ;
                    sub     MaxLin, 1
                    jnz     short _start
                    ;
@@:                 invoke  EndPage, _hpdc
                    cmp     eax, 0
                    jg      short @F
                    ;
                    invoke  EndDoc, _hpdc
                    stc
                    ret
                    ;
@@:                 clc
                    ret
PrintPage           endp
; 
TextPrint           proc    pRcl:DWORD, Lin:DWORD, Col:DWORD

                    mov     ebx, pRcl
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
TextPrint           endp
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu2       ; Choose File

                    ; 
                    ; Choose File
                    ; 
                    call    AbreFile

                case    IDM_Menu3       ; Print Text

                    ; 
                    ; Print Text
                    ; 
                    invoke  PrintText
                    
                case    IDM_Menu4       ; Close
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
                ;jmp     _WM_CLOSE
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
                ;
@@:             invoke    GlobalFree, _pFrmMem
                ;
                invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp    
; 
; Choose a File to open and then Open the file, get the length
; Read it to _bufferTxt and format each line to _bufferFrm
;
AbreFile        proc

                cmp     _hFile, 0
                je      short @F
                ;
                ; Close the previous            
                ; 
                invoke    CloseHandle, _hFile
                mov       _hFile, 0

                ; 
                ; Clean the previous
                ; 
@@:             mov     ebx, offset _FileName
                mov     dword ptr [ebx - 4], 0

                mov     _pTxtMem, 0

                ; 
                ; Get File Name to open
                ; 
                mov     _ofn.lStructSize, SIZEOF _ofn
                push    _hWnd
                pop     _ofn.hWndOwner

                push    _hInstance
                pop     _ofn.hInstance
                mov     _ofn.lpstrFilter, OFFSET _FilterString
                mov     _ofn.lpstrFile, OFFSET _FileName
                mov     _ofn.nMaxFile, MAXSIZE
                mov     _ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or \
                                    OFN_EXPLORER or OFN_HIDEREADONLY
                mov     _ofn.lpstrTitle, OFFSET _OurTitle
                
                invoke  GetOpenFileName, ADDR _ofn
                cmp     eax, TRUE
                je      short @F
                stc
                ret
                ;
@@:             mov     edx, ebx
                ;
_b:             cmp     byte ptr [edx], 0
                je      short @F
                ;             
                inc     dword ptr [ebx - 4]
                add     edx, 1
                jmp     short _b
                
                ; 
                ; Open File
                ; 
@@:             invoke    CreateFile, ebx, $ModoAberRd, $ShareFic, NULL,
                                           $AbreOuErro, $ArquivoAll, NULL
                cmp       eax, INVALID_HANDLE_VALUE
                je        short _erro                                       ; erro
                ;
                ; Save the handle
                ; 
                mov       _hFile, eax
                ;mov       ebx, eax
                ;
                ; Get the Length
                ; 
                invoke    GetFileSize, eax, NULL
                cmp       eax, INVALID_SET_FILE_POINTER
                jne	  short @F
                ;
                call      SendErro3
                call      CloseAll                
                stc
                ret

                ; 
                ; _lFile = File Length
                ; 
@@:             mov       _lFile, eax
                add       eax, 10
                invoke    AllocMemo, eax
                jnc       short @F
                
                call      SendErro3
                call      CloseAll
                stc
                ret
                
                ; 
                ;      Read File
                ; 
@@:             mov       _pTxtMem, eax
                add       eax, 8
                mov       _pTxtBuf, eax
                ;
                call      FileRead
                jnc       short @F
                ;
                call      CloseAll
                ret

                ; 
                ; Format
                ;       
@@:             call      FormatTxt
                call      CloseAll
                ret
                ;
_erro:          call      SendErro3
                call      CloseAll
                stc
                ret
AbreFile        endp 
; 
; Free memory alloc and close file
;
CloseAll        proc
                pushfd
                ;
                cmp       _pTxtMem, 0
                je        short @F
                ;
                invoke    GlobalFree, _pTxtMem
                mov       _pTxtMem, 0
                ;
@@:             cmp       _hFile, 0
                je        short @F
                
                invoke    CloseHandle, _hFile
                mov       _hFile, 0
   
@@:             popfd
                ret
CloseAll        endp
; 
; Input:
;       _hFile  - file handle
;       _lFile  - file length
;
FileRead        proc

                mov     eax, _lFile
                ;mov     ebx, offset _bufferTxt                
                mov     ebx, _pTxtBuf
                
                cmp     eax, dword ptr [ebx - 8]    ; max buffer length
                jbe     short @F

                invoke  MessageBox, _hWnd, addr _MsgErro4, addr _MsgTit4, MB_OK
                ;
                ; File is too long
                ; 
_erro:          mov       dword ptr [ebx - 4], 0      ; buffer length
                call      SendErro3
                stc
                ret
                ;
@@:             invoke    ReadFile, _hFile, ebx, _lFile, addr _BytesRead, NULL
                cmp       eax, 0
                jne	  short @F                 ; leu
                ;
                ; Erro
                ; 
                
                jmp       _erro
;.............................................................................
@@:             mov       eax, _BytesRead
                cmp	  eax, _lFile
                je        short @F
                ;
                call      SendErro3                
                stc
                ret
                ;
@@:             mov     edx, _pTxtBuf           ;offset _bufferTxt
                mov     dword ptr [edx - 4], eax
                ;
                add     eax, edx
                mov     _LastTxtBuf, eax        ; points to the end address
                                
                clc
                ret
FileRead        endp 
; ##############################################################################################
IniBufFrm       proc
                mov     eax, _pFrmBuf                   ;offset _bufferFrm
                cmp     eax, 0
                jne     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [eax - EndRegLst], 0
                mov     dword ptr [eax - CorRegLst], 0
                clc
                ret
IniBufFrm       endp
; 
; Read Text Buffer and convert each line to Frm buffer
;
FormatTxt       proc
                LOCAL   LenLine:DWORD
                ;
                call    IniBufFrm
                jnc     short @F
                ret
                ;
@@:             mov     esi, _pTxtBuf                       ; offset _bufferTxt
                cmp     dword ptr [esi - 4], 0
                jne     short _start
                ret
                ;
                ;
                ;
_cnv:           call    CnvToFrm
                ;
                ;
                ;
_start:         call    NxtLinFrm
                jnc     short @F
                ;
                ; File too long
                ;
                ret

@@:             call    FindCRLF
                jnc     short _next
                ;
                ; Fim
                ;
                cmp	ecx, _lFile
                je      short @F
                ret
                
                ; 
                ; it isnt a text file
                ; 
@@:             invoke  MessageBox, _hWnd, addr _MsgErro1, addr _MsgTit1, MB_OK
                ;
                call    IniBufFrm
                stc
                ret
                ;
_next:          cmp     ecx, 0
                je      short _start

                cmp     ecx, MAXCOLSIZE 
                jbe     short _cnv
                ;
                ; Line too long
                ;
                mov     eax, ecx
                sub     eax, MAXCOLSIZE
                mov     LenLine, eax

                mov     ecx, MAXCOLSIZE                
                call    CnvToFrm
                ;
                call    NxtLinFrm
                
                mov     ecx, LenLine
                jmp     short _next
FormatTxt       endp
; ----------------------------------------------------------------------------------------------
; Input:
;           ECX     - line length
;           EBX     - text buffer current position
;           EDI     - frm  buffer initial line position
;
CnvToFrm        proc

                mov     edx, edi
                ;                
_i:             movzx   eax, byte ptr [ebx]
                add     ebx, 1
                
                cmp     al, 09h
                jne     short @F
                
                ; 
                ; Convert this tab to 8 spaces
                ; 
                call    AddSpaces
                jnc     short _n
                ;
                ret
                ;
                ; Next Line
                ;
_erro:          push    eax
                    call    NxtLinFrm
                pop     eax
                jnc     short @F
                
                ret
                ;             
@@:             push    eax
                    mov     eax, dword ptr [edi - 4]
                    inc     eax
                    cmp     eax, MAXCOLSIZE 
                pop     eax
                ja      short _erro

                inc     dword ptr [edi - 4]
                ;
                mov     byte ptr [edx], al
                add     edx, 1
                ;
_n:             sub     ecx, 1
                jnz     short _i

                ; 
                ; End
                ; 
                ret
CnvToFrm        endp
; ----------------------------------------------------------------------------------------------
AddSpaces       proc
                push    ebx
                push    ecx
                ;
                mov     ebx, 8                      ; each TAB = 8 spaces
                mov     ecx, dword ptr [edi - 4]                
                ;
_start:         inc     ecx
                cmp     ecx, MAXCOLSIZE 
                jbe      short _next
                ;
                call    NxtLinFrm
                jc      short _exit

                mov     edx, edi
                mov     ecx, dword ptr [edi - 4]                
                add     ecx, 1

_next:          mov     dword ptr [edi - 4], ecx
                mov     byte ptr [edx], 20h
                add     edx, 1
                ;
                sub     ebx, 1
                jnz     short _start
                ;
                clc
_exit:          pop     ecx
                pop     ebx
                ret
AddSpaces       endp
; ----------------------------------------------------------------------------------------------
; Input:
;           ESI     - corrente
;
; Output:
;           EBX     - inicial
;           ESI     - prximo
;
;           ECX     - comprimento
;
FindCRLF        proc

                mov     ebx, esi
                xor     ecx, ecx
                jz      short _i
                ;
_n:             add     esi, 1
                cmp     esi, _LastTxtBuf
                jb      short _i
                ;
                mov     ecx, esi
                sub     ecx, ebx
                
                stc
                ret
                ;
_i:             movzx   eax, word ptr [esi]
                ;
                cmp     ax, 0D0Ah
                je      short _e
                
                cmp     ax, 0A0Dh
                jne     short _n
                ;
_e:             mov     ecx, esi
                sub     ecx, ebx
                
                add     esi, 2
                clc                
                ret
FindCRLF        endp
; ----------------------------------------------------------------------------------------------
; Output:
;           clc:    EDI - points to next line buffer
;       
;
NxtLinFrm       proc

                mov     edi, _pFrmBuf                   ;offset _bufferFrm
                mov     eax, dword ptr [edi - EndRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - MaxRegLst]
                jbe     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [edi - EndRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;
                mov     dword ptr [edi - 4], 0              ; string length  = 0
                ;                
                clc
                ret
NxtLinFrm       endp
; ----------------------------------------------------------------------------------------------
; Output:
;           EDI     - points to current frm line
;
GetNxtLin       proc

                mov     edi, _pFrmBuf                   ;offset _bufferFrm
                mov     eax, dword ptr [edi - CorRegLst]
                add     eax, 1
                cmp     eax, dword ptr [edi - EndRegLst]
                jbe     short @F
                stc
                ret
                ;
@@:             mov     dword ptr [edi - CorRegLst], eax
                ;
                sub     eax, 1
                mul     dword ptr [edi - LenRegLst]
                add     edi, eax
                ;                
                clc
                ret
GetNxtLin       endp
; 
                                include Printer10.inc
; 
; This procedures are to help me developing the prog...
; 
SendErro        proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgErro, addr _MsgTit1, MB_OK 	
                ;
                popad
                ret
SendErro        endp
; 
SendTeste       proc
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest, addr _MsgTit2, MB_OK 	
                ;
                popad
                ret
SendTeste       endp
; 
SendTeste5      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest5, addr _MsgTit5, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste5      endp
; 
SendTeste6      proc
                pushfd
                pushad
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest6, addr _MsgTit6, MB_OK 	
                ;
                popad
                popfd
                ret
SendTeste6      endp
; 
SendErro3       proc
                pushad  
                ;
                invoke  MessageBox, _hWnd, addr _MsgTest3, addr _MsgTit3, MB_OK 	
                ;
                popad
                ret
SendErro3       endp                
; ##############################################################################################
    end     start

